#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n, q, veg=0;

    cin>>n>>q;

    vector <int> x, d1, p1, veg1;

    for(int i=1; i<=n; i++)
    {
        int d, p;
        cin>>d>>p;

        d1.push_back(d);
        p1.push_back(p);
    }
    for(int i=0; i<q; i++)
    {
        veg=0;
        int q1;
        cin>>q1;
        for(int j=0; j<=q1; j++)
        {
            x.push_back(0);
        }
        for(int k=0; k<n; k++)
        {
            int l=d1[k]+p1[k];
            if(l>q1)
            {
                while((l-1)>q1)
                    l--;
            }
            for(int j=d1[k]; j<l; j++)
            {
                x[j]=1;
            }
        }
        for(int j=1; j<=q1; j++)
        {
            if(x[j]==1)
                veg++;
        }
        veg1.push_back(veg);
    }

    for(int i=0; i<veg1.size(); i++)
        cout<<veg1[i]<<endl;

    return 0;
}